#THE FOLLOWING CODE REQUIRES THE INSTALLATION OF THE COBRAPY AND OPENPYXL PACKAGES
import cobra
import openpyxl

#INPUT FILENAME (THE FILE MUST BE A GEM IN SMBL FORMAT)
modelname = input ('Please type model path and filename including file extension and press ENTER: ')

#READING OF THE MODEL 
model = cobra.io.read_sbml_model(modelname)

#GENERATION OF A NEW EXCEL FILE WITH HEADERS
wb = openpyxl.Workbook()
sh = wb['Sheet']
sh['A1'] = 'ID in model'
sh['B1'] = 'metabolite_name'
sh['C1'] = 'molecular formula'
sh['D1'] = 'compartment'
x = 2

#EXTRACTION OF INFORMATION GATHERED IN THE SMBL MODELç
print ('RETRIEVING MODEL METABOLITE INFORMATION...')
for i in model.metabolites:
	name = str(i)
	table = model.metabolites.get_by_id(name)
	sh['A'+str(x)] = table.id
	sh['B'+str(x)] = table.name
	sh['C'+str(x)] = table.formula
	sh['D'+str(x)] = table.compartment
	x += 1
print ('DONE')
print ('---')

#TYPE OUTPUT AND SAVE RESULTS
outname = input('Please type the name of your output tabular file and press ENTER: ')
wb.save(filename = str(outname)+'.xlsx')

	